//
// Copyright (c) 2008, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   19 Jul 08  Brian Frank  Creation
//
package fan.fwt;

import fan.sys.*;
import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Widget;
import org.eclipse.swt.events.*;

public class ComboPeer
  extends WidgetPeer
  implements Listener, ModifyListener
{

  public Widget create(Widget parent)
  {
    fan.fwt.Combo self = (fan.fwt.Combo)this.self;

    int style = self.dropDown.val ? SWT.DROP_DOWN : SWT.SIMPLE;
    if (self.editable.val) style |= SWT.READ_ONLY;
    Combo c = new Combo((Composite)parent, style);
    control = c;
    c.addListener(SWT.DefaultSelection, this);
    c.addModifyListener(this);
    setText(text);
    return c;
  }

  public Obj send(Str id, Obj arg)
  {
    if (id == fan.fwt.Combo.getTextId) return getText();
    if (id == fan.fwt.Combo.setTextId) return setText((Str)arg);
    return super.send(id, arg);
  }

  Str getText()
  {
    if (control == null) { return text; }
    return Str.make(((Combo)control).getText());
  }

  Obj setText(Str t)
  {
    if (control == null) { text = t; return null; }
    ((Combo)control).setText(t.val);
    return null;
  }

  public void sync(Str f)
  {
    Env env = Env.get();
    fan.fwt.Combo self = (fan.fwt.Combo)this.self;
    Combo c = (Combo)this.control;

    if (f == null || f == self.fontId)  c.setFont(env.font(self.font()));
    if (f == null || f == self.itemsId) c.setItems(self.items.toStrings());
  }

  public void handleEvent(Event event)
  {
    fan.fwt.Combo self = (fan.fwt.Combo)this.self;
    if (event.type == SWT.DefaultSelection)
    {
      if (self.onAction != null) self.onAction.call1(event(event));
    }
  }

  public void modifyText(ModifyEvent event)
  {
    fan.fwt.Combo self = (fan.fwt.Combo)this.self;
    if (self.onModify != null) self.onModify.call1(event(event));
  }

  Str text = Str.Empty;
}