//
// Copyright (c) 2008, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   12 Jun 08  Brian Frank  Creation
//
package fan.fwt;

import fan.sys.*;
import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.widgets.Widget;
import org.eclipse.swt.custom.CLabel;

public class LabelPeer extends WidgetPeer
{
  public Widget create(Widget parent)
  {
    return new CLabel((Composite)parent, 0);
  }

  public void sync(Str f)
  {
    Env env = Env.get();
    fan.fwt.Label self = (fan.fwt.Label)this.self;
    CLabel c = (CLabel)this.control;

    if (f == null || f == self.textId)   c.setText(self.text().val);
    if (f == null || f == self.imageId)  c.setImage(env.image(self.image()));
    if (f == null || f == self.fgId)     c.setForeground(env.color(self.fg()));
    if (f == null || f == self.bgId)     c.setBackground(env.color(self.bg()));
    if (f == null || f == self.fontId)   c.setFont(env.font(self.font()));
    if (f == null || f == self.halignId) c.setAlignment(style(self.halign()));
  }
}