//
// Copyright (c) 2008, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   19 Jun 08  Brian Frank  Creation
//
package fan.fwt;

import fan.sys.*;
import org.eclipse.swt.*;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.widgets.Widget;
import org.eclipse.swt.layout.*;

public class PanePeer extends WidgetPeer
{
  public Widget create(Widget parent)
  {
    Composite c = new Composite((Composite)parent, 0);
    c.setLayout(new PaneLayout());
    return c;
  }

  public void sync(Str f)
  {
  }

  class PaneLayout extends Layout
  {
    protected Point computeSize(Composite composite, int wHint, int hHint, boolean flushCache)
    {
      Hints hints = Hints.make(
        wHint == SWT.DEFAULT ? null : Int.make(wHint),
        hHint == SWT.DEFAULT ? null : Int.make(hHint));
      Size s = ((Pane)self).prefSize(hints);
      if (s == null) return new Point(20, 20);
      return new Point((int)s.w.val, (int)s.h.val);
    }

    protected void layout(Composite composite, boolean flushCache)
    {
      Rectangle rect = composite.getClientArea();
      if (rect.x != 0 || rect.y != 0)
        System.out.println("WARNING: we got a problem houston with client area " + composite);
      ((Pane)self).onLayout();
    }
  }

}