//
// Copyright (c) 2008, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   10 Jul 08  Brian Frank  Creation
//
package fan.fwt;

import fan.sys.*;
import fan.sys.List;
import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.widgets.Widget;
import org.eclipse.swt.custom.SashForm;

public class SashPanePeer extends WidgetPeer
{
  public Widget create(Widget parent)
  {
    SashPane self = (SashPane)this.self;
    control = new SashForm((Composite)parent, orientation(self.orientation));
    setWeights(weights);
    return control;
  }

  public Obj send(Str id, Obj arg)
  {
    if (id == SashPane.getWeightsId) return getWeights();
    if (id == SashPane.setWeightsId) return setWeights((List)arg);
    return super.send(id, arg);
  }

  List getWeights()
  {
    List list = new List(Sys.IntType);
    if (control == null) { return  list; }
    int[] w = ((SashForm)control).getWeights();
    for (int i=0; i<w.length; ++i) list.add(Int.make(i));
    return list;
  }

  Obj setWeights(List w)
  {
// TODO: how to deal with weights.length != children.length
    if (w == null) return null;
    if (control == null) { weights = w; return null; }
    ((SashForm)control).setWeights(w.toInts());
    return null;
  }

  public void sync(Str f)
  {
    //SashPane self = (SashPane)this.self;
    //SashForm c = (SashForm)this.control;
  }

  List weights = null;
}