//
// Copyright (c) 2008, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   12 Jun 08  Brian Frank  Creation
//
package fan.fwt;

import fan.sys.*;
import org.eclipse.swt.*;
import org.eclipse.swt.browser.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.widgets.Widget;

public class WebBrowserPeer extends WidgetPeer
{

//////////////////////////////////////////////////////////////////////////
// WidgetPeer
//////////////////////////////////////////////////////////////////////////

  public Widget create(Widget parent)
  {
    return new Browser((Composite)parent, 0);
  }

  public void sync(Str id)
  {
    //WebBrowser self = (WebBrowser)this.self;
    //Browser b = (Browser)this.control;
    //if (id == null || id == self.titleId) shell.setText(self.title().val);
  }

  public Obj send(Str id, Obj arg)
  {
    if (control == null) return null;
    if (id == WebBrowser.loadId)    { load((Uri)arg); return null; }
    if (id == WebBrowser.refreshId) { refresh(); return null; }
    if (id == WebBrowser.stopId)    { stop(); return null; }
    if (id == WebBrowser.backId)    { back(); return null; }
    if (id == WebBrowser.forwardId) { forward(); return null; }
    return super.send(id, arg);
  }

//////////////////////////////////////////////////////////////////////////
// Commands
//////////////////////////////////////////////////////////////////////////

  public void load(Uri uri)
  {
    Browser b = (Browser)this.control;
    b.setUrl(uri.toString());
  }

  public void refresh()
  {
    Browser b = (Browser)this.control;
    b.refresh();
  }

  public void stop()
  {
    Browser b = (Browser)this.control;
    b.stop();
  }

  public void back()
  {
    Browser b = (Browser)this.control;
    b.back();
  }

  public void forward()
  {
    Browser b = (Browser)this.control;
    b.forward();
  }

}