//
// Copyright (c) 2008, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   12 Jun 08  Brian Frank  Creation
//
package fan.fwt;

import fan.sys.*;
import org.eclipse.swt.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.widgets.Widget;
import org.eclipse.swt.layout.*;

public class WindowPeer extends WidgetPeer
{

  public Widget create(Widget parent)
  {
    // window uses open, not normal attach process
    throw new IllegalStateException();
  }

  public void sync(Str id)
  {
    Env env = Env.get();
    Window self = (Window)this.self;
    Shell shell = (Shell)this.control;
    if (id == null || id == self.iconId) shell.setImage(env.image(self.icon));
    if (id == null || id == self.titleId) shell.setText(self.title.val);
  }

  public Obj send(Str id, Obj arg)
  {
    if (id == Window.openId) { open(); return null; }
    if (id == Window.closeId) { close(); return null; }
    return super.send(id, arg);
  }

//////////////////////////////////////////////////////////////////////////
// Window
//////////////////////////////////////////////////////////////////////////

// TODO

  public void open()
  {
    if (control != null) return;

    Env env = null;
    Shell shell;
    if (parent() == null)
    {
      env = Env.get();
      shell = new Shell(env.display);
    }
    else
    {
      shell = new Shell((Shell)parentControl());
    }
    shell.setLayout(new FillLayout());
    attachTo(shell);

    shell.open();

    if (env != null) env.eventLoop(shell);
  }

  public void close()
  {
    if (control == null) return;
    Shell shell = (Shell)control;
    shell.close();
    detach(self);
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  Shell shell;

}