//
// Copyright (c) 2008, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   9 Jul 08  Brian Frank  Creation
//

**
** CommandTest
**
class CommandTest : Test
{

  Void testBinding()
  {
    count := 0
    c := Command("Foo", null) |,| { count++ }
    m := MenuItem { command = c }
    verifyEq(m.text, "Foo")
    verifyEq(m.enabled, true)
    verifyEq(c.widgets, Widget[m])

    c.enabled = false
    verifyEq(m.enabled, false)

    b := Button { command = c }
    verifyEq(b.text, "Foo")
    verifyEq(b.enabled, false)
    verifyEq(c.widgets, Widget[m, b])

    c.enabled = true
    verifyEq(m.enabled, true)
    verifyEq(b.enabled, true)

    m.command = null
    verifyEq(c.widgets, Widget[b])
  }

}