//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   14 Jan 08  John Sublett  Creation
//

using sql

**
** ColDef for Enum data types.
**
@havenCol=Enum#
const internal class EnumCol : ColDef
{
  new make() : super.make() {}

  new makeForField(HavenService haven, Field field) : super(haven, field)
  {
  }

  override Str toSql(Obj o)
  {
    return ((Enum)o).ordinal.toStr
  }

  override Void setFieldFromRow(Obj obj, Row row, HavenNamespace ns)
  {
    v := field.of.field("values")
    field.set(obj, ((Obj[])v.get)[row.get((Col)row.type.field(field.name))])
  }

  override Obj rowValue(Row row, Col col)
  {
    v := field.of.field("values")
    return ((Obj[])v.get)[row.get(col)]
  }

  override Obj paramValue(Obj o, Str:Obj params)
  {
    params[field.name] = ((Enum)o).ordinal
    return ((Enum)o).ordinal
  }

  override Str sqlType()
  {
    return "INTEGER"
  }
}