//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   09 Feb 08  John Sublett  Creation
//

using sql

**
** Generic ColDef for the simple data types.
**
const internal class SimpleCol : ColDef
{
  new make() : super.make() {}
  
  new makeForField(HavenService haven, Field field) :super(haven, field)
  {
    len = field.facet("max", null)
    if (len == null)
      len = field.of.facet("max", null)
    if (len == null)
      throw HavenErr.make("'max' facet required either on field type or field for simple fields.");

    //fromStr = field.of.method("fromStr")
  }
  
  override Str toSql(Obj o)
  {
    return "'" + o.toStr + "'"
  }

  override Void setFieldFromRow(Obj obj, Row row, HavenNamespace ns)
  {
    f := field
    fromStr := f.of.method("fromStr")
    f.set(obj, fromStr.call1(row.get((Col)row.type.field(f.name))))
  }
  
  override Obj rowValue(Row row, Col col)
  {
    f := field
    fromStr := f.of.method("fromStr")
    return fromStr.call1(row.get(col))
  }
  
  override Obj paramValue(Obj o, Str:Obj params)
  {
    v := o.toStr
    if (params != null) params[field.name] = v
    return v
  }
  
  override Str sqlType()
  {
    return "VARCHAR($len)"
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  //private const Method fromStr
  private const Int len
}