//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   01 Jan 08  John Sublett  Creation
//

using sql

**
** Test the DbModel class.
**
class DbModelTest : Test
{
  Void test()
  {
    build
    missingDepends
      }

  DbModel newModel()
  {
    model := DbModel.make
    model.addType(Chapter#)
    model.addType(Book#)
    model.addType(Person#)
    model.addType(Publisher#)
    model.commit

    return model
  }

  Void build()
  {
    model := newModel

    createOrder := model.listTypes
    verifyEq(createOrder[0], Person#)
    verifyEq(createOrder[1], Publisher#)
    verifyEq(createOrder[2], Book#)
    verifyEq(createOrder[3], Chapter#)
  }

  Void missingDepends()
  {
    model := DbModel.make
    model.addType(Chapter#)
    model.addType(Person#)
    model.addType(Publisher#)

    verifyErr(HavenErr#) |,|
    {
      model.commit
    }
  }
}