//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   01 Jan 08  John Sublett  Creation
//

using sql

**
** Test behavior of the TypeGraph.
**
class TypeGraphTest : Test
{
  Void test()
  {
    sort
    cycle
  }

  Void sort()
  {
    graph := TypeGraph.make
    graph.addDependency(Book#, Person#)
    graph.addDependency(Book#, Publisher#)
    graph.addDependency(Chapter#, Book#)

    types := graph.sort
    verifyEq(types[0], Person#)
    verifyEq(types[1], Publisher#)
    verifyEq(types[2], Book#)
    verifyEq(types[3], Chapter#)
  }

  Void cycle()
  {
    graph := TypeGraph.make
    graph.addDependency(Book#, Person#)
    graph.addDependency(Person#, Book#)
    try
    {
      graph.sort
    }
    catch(Err e)
    {
      verify(e.message.startsWith("Cycle detected"),
             "Incorrect exception: " + e.message)
    }

    graph = TypeGraph.make
    graph.addDependency(Book#, Person#)
    graph.addDependency(Person#, Chapter#)
    graph.addDependency(Chapter#, Book#)
    try
    {
      graph.sort
    }
    catch(Err e)
    {
      verify(e.message.startsWith("Cycle detected"),
             "Incorrect exception: " + e.message)
    }
  }
}
