//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   6 Jan 06  Andy Frank  Creation
//

using System;
using Fan.Sys;

namespace Fanx.Tools
{
  /// <summary>
  /// Fan Shell
  /// </summary>
  ///
  public class Fansh : Tool
  {

  //////////////////////////////////////////////////////////////////////////
  // Run
  //////////////////////////////////////////////////////////////////////////

    public static int run(string reserved)
    {
      sysInit(reserved);
      MainThread t = new MainThread();
      t.start().join();
      return t.ret;
    }

    class MainThread : Thread
    {
      public MainThread() : base(Str.make("main")) {}
      public override Obj run()
      {
        ret = doRun();
        return null;
      }
      public int ret;
    }

    static int doRun()
    {
      return new Fan().execute("fansh::Main.main", Fan.cmdLineArgs());
    }

  }
}
